;Autor: LuckyLuke
;http://www.purebasic.fr/english/viewtopic.php?p=29907#p29907

EnableExplicit

Define EventID
Global hFindReplace.l
Global uFindReplaceMsg.l
Global find.s = ""
Global replace.s = ""
Global frpl.FINDREPLACE
Global findtext.FINDTEXTEX

#Editor = 0
#ST_DEFAULT = 0
#ST_KEEPUNDO = 1
#ST_SELECTION = 2
#FINDMSGSTRING = "commdlg_FindReplace"

Procedure FindText()
  If hFindReplace= 0
    frpl\lStructSize = SizeOf(FINDREPLACE)
    frpl\hwndOwner = WindowID(0)
    frpl\hInstance = GetModuleHandle_(0)
    frpl\flags = #FR_DOWN
    frpl\lpstrFindWhat = @find
    frpl\wFindWhatLen = 80  ; Miminum Length = 80
    hFindReplace = FindText_(frpl)
  EndIf
EndProcedure

Procedure ReplaceText()
  If hFindReplace= 0
    frpl\lStructSize = SizeOf(FINDREPLACE)
    frpl\hwndOwner = WindowID(0)
    frpl\hInstance = GetModuleHandle_(0)
    frpl\flags = #FR_DOWN
    frpl\lpstrFindWhat = @find
    frpl\wFindWhatLen = 80
    frpl\lpstrReplaceWith = @replace   
    frpl\wReplaceWithLen = 80
    hFindReplace = ReplaceText_(frpl)
  EndIf
EndProcedure

Procedure.l WindowCallback(WindowID.l, Message.l, wParam.l, lParam.l)
  Protected Result
  Protected settext.SETTEXTEX
  Protected *lpfr.FINDREPLACE
  Protected flag
  Protected uFlags
  Protected what$
  Protected a
  Protected c
  Protected replace$
  
  Result = #PB_ProcessPureBasicEvents
  
  If message = uFindReplaceMsg
    *lpfr = lParam
    
    flag = *lpfr\flags
    
    ;Check if dialog window is closed
    If flag & #FR_DIALOGTERM
      hFindReplace = 0
      ProcedureReturn 0
    EndIf   
    
    SetFocus_(GadgetID(#Editor))
    
    If flag & #FR_FINDNEXT
      uFlags = uFlags | #FR_FINDNEXT
    EndIf
    If flag & #FR_REPLACE
      uFlags = uFlags | #FR_REPLACE
    EndIf
    If flag & #FR_REPLACEALL
      uFlags = uFlags | #FR_REPLACEALL
    EndIf 
    If flag & #FR_DOWN
      uFlags = uFlags | #FR_DOWN
    EndIf
    If flag & #FR_MATCHCASE
      uFlags = uFlags | #FR_MATCHCASE
    EndIf
    If flag & #FR_WHOLEWORD
      uFlags = uFlags | #FR_WHOLEWORD
    EndIf   
    
    what$ = PeekS(*lpfr\lpstrFindWhat)   
    findtext\lpstrText = @what$
    
    If uFlags & #FR_FINDNEXT
      SendMessage_(GadgetID(#Editor),#EM_EXGETSEL,0,@findtext\chrg)
      
      If (findtext\chrg\cpMin <> findtext\chrg\cpMax And uFlags & #FR_DOWN) Or (uFlags & #FR_DOWN)
        findtext\chrg\cpMin = findtext\chrg\cpMax
        findtext\chrg\cpMax = -1
      Else
        findtext\chrg\cpMax = 0
      EndIf
      
      c = SendMessage_(GadgetID(#Editor),#EM_FINDTEXT, uFlags, findtext)
      If c <> -1
        findtext\chrgText\cpMin = c
        findtext\chrgText\cpMax = c + Len(what$)     
        SendMessage_(GadgetID(#Editor),#EM_EXSETSEL, 0, findtext\chrgText)
      Else
        MessageRequester("Information","Cannot find " + what$, #PB_MessageRequester_Ok) 
      EndIf
    ElseIf uFlags & #FR_REPLACEALL
      replace$ = PeekS(*lpfr\lpstrReplaceWith)
      findtext\chrg\cpMin = 0
      findtext\chrg\cpMax = -1
      
      settext\flags = #ST_SELECTION
      settext\codepage = #CP_ACP
      a = 0
      While a = 0
        c = SendMessage_(GadgetID(#Editor), #EM_FINDTEXTEX, uFlags, findtext)
        If c = -1
          a=1
        Else 
          SendMessage_(GadgetID(#Editor), #EM_EXSETSEL, 0, findtext\chrgText)
          SendMessage_(GadgetID(#Editor), #EM_SETTEXTEX, settext, @Replace$)
          findtext\chrg\cpMin = c + Len(replace$)
        EndIf
      Wend
    Else
      replace$ = PeekS(*lpfr\lpstrReplaceWith)
      SendMessage_(GadgetID(#Editor),#EM_EXGETSEL,0,@findtext\chrg)
      
      If (findtext\chrg\cpMin <> findtext\chrg\cpMax And uFlags & #FR_DOWN) Or (uFlags & #FR_DOWN)
        findtext\chrg\cpMin = findtext\chrg\cpMax
        findtext\chrg\cpMax = -1
      Else
        findtext\chrg\cpMax = 0
      EndIf
      
      settext\flags = #ST_SELECTION
      settext\codepage = #CP_ACP
      
      c = SendMessage_(GadgetID(#Editor), #EM_FINDTEXTEX, uFlags, findtext)
      If c <> -1
        SendMessage_(GadgetID(#Editor), #EM_EXSETSEL, 0, findtext\chrgText)
        SendMessage_(GadgetID(#Editor), #EM_SETTEXTEX, settext, @Replace$)
      Else
        MessageRequester("Information","Cannot find " + what$, #PB_MessageRequester_Ok) 
      EndIf
    EndIf
  EndIf
  
  ProcedureReturn Result
EndProcedure

If OpenWindow(0, 0, 0, 500, 400, "Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  EditorGadget(#Editor, 0, 0, WindowWidth(0), WindowHeight(0)-40, 0)
  ButtonGadget(1, WindowWidth(0)-320, WindowHeight(0)-30, 150, 20, "Suchen", 0)
  ButtonGadget(2, WindowWidth(0)-160, WindowHeight(0)-30, 150, 20, "Suchen und Ersetzen", 0)
  
  uFindReplaceMsg = RegisterWindowMessage_(#FINDMSGSTRING)
  SetWindowCallback(@WindowCallback())
  
  Repeat
    EventID = WaitWindowEvent()
    If EventID = #PB_Event_Gadget
      Select EventGadget()
        Case 1
          FindText()
        Case 2
          ReplaceText()
      EndSelect
    EndIf
    If EventID = #PB_Event_CloseWindow
      End
    EndIf
  ForEver
EndIf
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP
; EnableUser
; EnableCompileCount = 0
; EnableBuildCount = 0