;Autor: SFSxOI, ts-soft
;http://www.purebasic.fr/english/viewtopic.php?p=178740#p178740

EnableExplicit

Define ConsoleHandle

If OpenLibrary(0, "Kernel32.dll")
  Prototype GetConsoleWindow()
  Define GetConsoleWindow.GetConsoleWindow = GetFunction(0, "GetConsoleWindow")
  CloseLibrary(0)
EndIf

#DWM_BB_ENABLE = 1
#DWM_BB_BLURREGION = 2
#DWM_BB_TRANSITIONONMAXIMIZED = 4

Structure DWM_BLURBEHIND
  dwFlags.l
  fEnable.b
  hRgnBlur.l
  fTransitionOnMaximized.b
EndStructure

Procedure EnableBlurBehindWindow(hWnd, enable.b = #True, region.l = 0, transitionOnMaximized.b = #False)
  Protected blurBehind.DWM_BLURBEHIND
  Protected Lib
  Protected *pAfunc
 
  blurBehind\dwFlags = #DWM_BB_ENABLE | #DWM_BB_TRANSITIONONMAXIMIZED
  ;blurBehind\dwFlags = #DWM_BB_ENABLE
  blurBehind\fEnable = enable
  blurBehind\fTransitionOnMaximized = transitionOnMaximized
 
  ;Lib = LoadLibrary_("dwmapi.dll")
  Lib = OpenLibrary(#PB_Any, "dwmapi.dll")
  If Lib
    If (enable And 0) <> region
      blurBehind\dwFlags = #DWM_BB_BLURREGION
      blurBehind\hRgnBlur = region
    EndIf
      ;*pAfunc = GetProcAddress_(Lib, "DwmEnableBlurBehindWindow")
      *pAfunc = GetFunction(Lib,  "DwmEnableBlurBehindWindow")
      CallFunctionFast(*pAfunc, hWnd, @blurBehind)
      ;FreeLibrary_(Lib)
      CloseLibrary(Lib)
  EndIf
   
  ProcedureReturn
EndProcedure

If OpenConsole("Meine Konsole")
  ConsoleHandle = GetConsoleWindow()
  EnableBlurBehindWindow(ConsoleHandle)
  
  Input()
  
  CloseConsole()
EndIf
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableXP
; EnableUser
; EnableCompileCount = 0
; EnableBuildCount = 0