;Autor: edel, ts-soft
;http://www.purebasic.fr/german/viewtopic.php?p=304094#p304094

EnableExplicit

Define EventID

Import "window.lib"
   PB_Window_ProcessEvent(a,b,c,d)
 
  PB_Window_NonBlockResizeInit()
 
  PB_Window_Icon
  PB_Window_Cursor
  PB_Window_Objects
  PB_Object_GetOrAllocateID(*Object,id)
EndImport

Procedure NewOpenWindow(id,x,y,cx,cy,title.s,flags=#WS_VISIBLE|#WS_OVERLAPPEDWINDOW,parent=0)
  Protected wnd.wndclass
  Protected classname.s = "MY_OWN_CLASS"
  Protected *WinObj.integer
  Protected hWnd.i
  Protected rc.rect
  
  With wnd
    \style          = #CS_HREDRAW|#CS_VREDRAW
    \lpfnWndProc    = @PB_Window_ProcessEvent()
    \hInstance      = GetModuleHandle_(0)
    \hIcon          = PB_Window_Icon
    \hCursor        = PB_Window_Cursor
    \lpszClassName  = @classname
    \hbrBackground  = #COLOR_WINDOW
    \cbWndExtra     = 0
    \cbClsExtra     = 0
  EndWith
  
  If RegisterClass_(wnd)
    SetRect_(rc,0,0,cx,cy)
    AdjustWindowRectEx_(rc,flags,0,#WS_EX_WINDOWEDGE)
    
    If x = #PB_Ignore Or y = #PB_Ignore
      x = #CW_USEDEFAULT
      y = #CW_USEDEFAULT
    EndIf   
    
    ;PB_Window_NonBlockResizeInit()
   
    hWnd = CreateWindowEx_(#WS_EX_WINDOWEDGE,classname,title,flags,x,y,rc\right-rc\left,rc\bottom-rc\top,parent,0,GetModuleHandle_(0),0)
   
    If hWnd
      *WinObj   = PB_Object_GetOrAllocateID(PB_Window_Objects,id)
      *WinObj\i = hWnd

      If id = #PB_Any
        SetProp_(hWnd,"Pb_WindowID",*WinObj+1)
      Else
        SetProp_(hWnd,"Pb_WindowID",id+1)
      EndIf
     
      UseGadgetList(hWnd)
     
    Else
      UnregisterClass_(GetModuleHandle_(0),classname)
    EndIf
   
  EndIf

  If id = #PB_Any
    id = *WinObj
  Else
    id = hWnd
  EndIf
 
  ProcedureReturn id
EndProcedure

If NewOpenWindow(0, 300, 300, 500, 400, "Window", #PB_Window_SystemMenu | #WS_VISIBLE)
  
  Repeat
    EventID = WaitWindowEvent()
    If EventID = #PB_Event_CloseWindow
      End
    EndIf
  ForEver
EndIf
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP
; EnableUser
; EnableCompileCount = 0
; EnableBuildCount = 0