EnableExplicit

Structure IO_COUNTERS
  ReadOperationCount.q
  WriteOperationCount.q
  OtherOperationCount.q
  ReadTransferCount.q
  WriteTransferCount.q
  OtherTransferCount.q
EndStructure

If OpenLibrary(0, "Kernel32.dll")
  Prototype GetProcessIoCounters(hProcess, lpIoCounters)
  Define GetProcessIoCounters.GetProcessIoCounters = GetFunction(0, "GetProcessIoCounters")
  CloseLibrary(0)
EndIf

Define IO_COUNTERS.IO_COUNTERS

GetProcessIoCounters(GetCurrentProcess_(), IO_COUNTERS)

Debug "EA-Andere: " + IO_COUNTERS\OtherOperationCount
Debug "EA-Andere: " + IO_COUNTERS\OtherTransferCount + " Bytes"
Debug "EA-Lesen: " + IO_COUNTERS\ReadOperationCount
Debug "EA-Lesen: " + IO_COUNTERS\ReadTransferCount + " Bytes"
Debug "EA-Schreiben: " + IO_COUNTERS\WriteOperationCount
Debug "EA-Schreiben: " + IO_COUNTERS\WriteTransferCount + " Bytes"