;Autor: ts-soft
;http://www.purebasic.fr/german/viewtopic.php?p=306833#p306833

EnableExplicit

#MB_TIMEDOUT = $7D00

Prototype.i MBTimeOut(hwnd.i, lpText.s, lpCaption.s, uType.l, wLanguageId.w, dwMilliseconds.l)

Procedure MessageBoxTimeout(hwnd.i, lpText.s, lpCaption.s, uType.l, dwMilliseconds.l)
  Protected hDLL = GetModuleHandle_("user32")
  Protected FuncString.s
  Protected MBTimeOut.MBTimeOut
 
  CompilerIf #PB_Compiler_Unicode
    FuncString.s = Space(17)
    PokeS(@FuncString, "MessageBoxTimeoutW", -1, #PB_Ascii)
  CompilerElse
    FuncString.s = "MessageBoxTimeoutA"
  CompilerEndIf
 
  If hDLL
    MBTimeOut = GetProcAddress_(hDLL, @FuncString)
    If MBTimeOut
      ProcedureReturn MBTimeOut(hwnd, lpText, lpCaption, uType, 0, dwMilliseconds)
    EndIf
  Else
    Debug "Error: MessageBoxTimeout"
  EndIf
EndProcedure

Select MessageBoxTimeout(0, "Mgen Sie PureBasic?" + #LF$ + "Sie haben 5 Sekunden zu antworten!", "Frage:", #MB_YESNO, 5000)
  Case #IDYES
    Debug "Sie haben 'Ja' gewhlt!"
  Case #IDNO
    Debug "Sie haben 'Nein' gewhlt!"
  Case #MB_TIMEDOUT
    Debug "Sie waren zu langsam ;-)"
EndSelect
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP
; EnableUser
; EnableCompileCount = 0
; EnableBuildCount = 0