;Autor: auser
;http://www.purebasic.fr/english/viewtopic.php?p=350031#p350031
;Ab Vista

EnableExplicit

Prototype ProtoShutdownBlockReasonCreate(hWnd.i, *pwszReason)
Prototype ProtoShutdownBlockReasonDestroy(hWnd.i)

If OpenLibrary(0, "user32.dll")
  Global ShutdownBlockReasonCreate.ProtoShutdownBlockReasonCreate = GetFunction(0, "ShutdownBlockReasonCreate")
  Global ShutdownBlockReasonDestroy.ProtoShutdownBlockReasonDestroy = GetFunction(0, "ShutdownBlockReasonDestroy")
  CloseLibrary(0)
EndIf

Procedure unicodePtr(string.s)
  Protected *ptr
  
  If string.s
    *ptr = AllocateMemory(StringByteLength(string.s, #PB_Unicode))
    PokeS(*ptr, string.s, StringByteLength(string.s, #PB_Unicode), #PB_Unicode)
    ProcedureReturn(*ptr)
  EndIf     
EndProcedure
Procedure WindowsCallback(WindowID, Message, wParam, lParam)
  Protected block_reason.s
  Protected result
  
  If Message=#WM_QUERYENDSESSION
   
    block_reason.s = "Download is still in progress."
   
    ShutdownBlockReasonCreate(WindowID(0), unicodePtr(block_reason.s))
    result = MessageRequester("Warning", block_reason.s+" Abort shutdown?", #PB_MessageRequester_YesNoCancel)
    If result = #PB_MessageRequester_Yes
      AbortSystemShutdown_(#Null)
    Else 
      ShutdownBlockReasonDestroy(WindowID(0))
      ProcedureReturn #True
    EndIf
    ProcedureReturn #False
  Else
    ProcedureReturn #PB_ProcessPureBasicEvents
  EndIf
EndProcedure

If OpenWindow(0, 0, 0, 200, 100, "Shutdown and wait")
  SetWindowCallback(@WindowsCallback())
  
  Repeat
  Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf 