;Ab Windows 8

EnableExplicit

#FirmwareTypeUnknown = 0
#FirmwareTypeBios = 1
#FirmwareTypeUefi = 2
#FirmwareTypeMax = 3

If OpenLibrary(0, "Kernel32.dll")
  Prototype GetFirmwareType(FirmwareType)
  Define GetFirmwareType.GetFirmwareType = GetFunction(0, "GetFirmwareType")
  CloseLibrary(0)
EndIf

Define FirmwareType

GetFirmwareType(@FirmwareType)

Select FirmwareType
  Case #FirmwareTypeUnknown
    Debug "The firmware type is unknown."
  Case #FirmwareTypeBios
    Debug "The computer booted in legacy BIOS mode."
  Case #FirmwareTypeUefi
    Debug "The computer booted in UEFI mode."
  Case #FirmwareTypeMax
    Debug "Not implemented."
EndSelect