;Ab Vista

EnableExplicit

Define pdwReturnedProductType

#PRODUCT_BUSINESS = $00000006
#PRODUCT_BUSINESS_N = $00000010
#PRODUCT_CLUSTER_SERVER = $00000012
#PRODUCT_DATACENTER_SERVER = $00000008
#PRODUCT_DATACENTER_SERVER_CORE = $0000000C
#PRODUCT_DATACENTER_SERVER_CORE_V = $00000027
#PRODUCT_DATACENTER_SERVER_V = $00000025
#PRODUCT_ENTERPRISE = $00000004
#PRODUCT_ENTERPRISE_E = $00000046
#PRODUCT_ENTERPRISE_N = $0000001B
#PRODUCT_ENTERPRISE_SERVER = $0000000A
#PRODUCT_ENTERPRISE_SERVER_CORE = $0000000E
#PRODUCT_ENTERPRISE_SERVER_CORE_V = $00000029
#PRODUCT_ENTERPRISE_SERVER_IA64 = $0000000F
#PRODUCT_ENTERPRISE_SERVER_V = $00000026
#PRODUCT_HOME_BASIC = $00000002
#PRODUCT_HOME_BASIC_E = $00000043
#PRODUCT_HOME_BASIC_N = $00000005
#PRODUCT_HOME_PREMIUM = $00000003
#PRODUCT_HOME_PREMIUM_E = $00000044
#PRODUCT_HOME_PREMIUM_N = $0000001A
#PRODUCT_HYPERV = $0000002A
#PRODUCT_MEDIUMBUSINESS_SERVER_MANAGEMENT = $0000001E
#PRODUCT_MEDIUMBUSINESS_SERVER_MESSAGING = $00000020
#PRODUCT_MEDIUMBUSINESS_SERVER_SECURITY = $0000001F
#PRODUCT_PROFESSIONAL = $00000030
#PRODUCT_PROFESSIONAL_E = $00000045
#PRODUCT_PROFESSIONAL_N = $00000031
#PRODUCT_SERVER_FOR_SMALLBUSINESS = $00000018
#PRODUCT_SERVER_FOR_SMALLBUSINESS_V = $00000023
#PRODUCT_SERVER_FOUNDATION = $00000021
#PRODUCT_HOME_PREMIUM_SERVER = $00000022
#PRODUCT_SB_SOLUTION_SERVER = $00000032
#PRODUCT_HOME_SERVER = $00000013
#PRODUCT_SMALLBUSINESS_SERVER = $00000009
#PRODUCT_SOLUTION_EMBEDDEDSERVER = $00000038
#PRODUCT_STANDARD_SERVER = $00000007
#PRODUCT_STANDARD_SERVER_CORE  = $0000000D
#PRODUCT_STANDARD_SERVER_CORE_V = $00000028
#PRODUCT_STANDARD_SERVER_V = $00000024
#PRODUCT_STARTER = $0000000B
#PRODUCT_STARTER_E = $00000042
#PRODUCT_STARTER_N = $0000002F
#PRODUCT_STORAGE_ENTERPRISE_SERVER = $00000017
#PRODUCT_STORAGE_EXPRESS_SERVER = $00000014
#PRODUCT_STORAGE_STANDARD_SERVER = $00000015
#PRODUCT_STORAGE_WORKGROUP_SERVER = $00000016
#PRODUCT_UNDEFINED = $00000000
#PRODUCT_ULTIMATE = $00000001
#PRODUCT_ULTIMATE_E = $00000047
#PRODUCT_ULTIMATE_N = $0000001C
#PRODUCT_WEB_SERVER = $00000011
#PRODUCT_WEB_SERVER_CORE = $0000001D

If OpenLibrary(0,"Kernel32.dll")
  Prototype.l GetProductInfo(dwOSMajorVersion, dwOSMinorVersion, dwSpMajorVersion, dwSpMinorVersion, pdwReturnedProductType)
  Define GetProductInfo.GetProductInfo = GetFunction(0,"GetProductInfo")   
  
  GetProductInfo(6, 0, 0, 0, @pdwReturnedProductType)
  
  Select pdwReturnedProductType
    Case #PRODUCT_BUSINESS
      MessageRequester("", "Windows-Versionsbezeichnung: Business", 0)
    Case #PRODUCT_BUSINESS_N
      MessageRequester("", "Windows-Versionsbezeichnung: Business N", 0)
    Case #PRODUCT_CLUSTER_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: HPC Edition", 0)
    Case #PRODUCT_DATACENTER_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Server Datacenter (full installation)", 0)
    Case #PRODUCT_DATACENTER_SERVER_CORE
      MessageRequester("", "Windows-Versionsbezeichnung: Server Datacenter (core installation)", 0)
    Case #PRODUCT_DATACENTER_SERVER_CORE_V
      MessageRequester("", "Windows-Versionsbezeichnung: Server Datacenter without Hyper-V (core installation)", 0)
    Case #PRODUCT_DATACENTER_SERVER_V
      MessageRequester("", "Windows-Versionsbezeichnung: Server Datacenter without Hyper-V (full installation)", 0)
    Case #PRODUCT_ENTERPRISE
      MessageRequester("", "Windows-Versionsbezeichnung: Enterprise", 0)
    Case #PRODUCT_ENTERPRISE_E
      MessageRequester("", "Windows-Versionsbezeichnung: Enterprise - Not supported", 0)
    Case #PRODUCT_ENTERPRISE_N
      MessageRequester("", "Windows-Versionsbezeichnung: Enterprise N", 0)
    Case #PRODUCT_ENTERPRISE_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Server Enterprise (full installation)", 0)
    Case #PRODUCT_ENTERPRISE_SERVER_CORE
      MessageRequester("", "Windows-Versionsbezeichnung: Server Enterprise (core installation)", 0)
    Case #PRODUCT_ENTERPRISE_SERVER_CORE_V
      MessageRequester("", "Windows-Versionsbezeichnung: Server Enterprise without Hyper-V (core installation) ", 0)
    Case #PRODUCT_ENTERPRISE_SERVER_IA64
      MessageRequester("", "Windows-Versionsbezeichnung: Server Enterprise for Itanium-based Systems", 0)
    Case #PRODUCT_ENTERPRISE_SERVER_V
      MessageRequester("", "Windows-Versionsbezeichnung: Server Enterprise without Hyper-V (full installation)", 0)
    Case #PRODUCT_HOME_BASIC
      MessageRequester("", "Windows-Versionsbezeichnung: Home Basic", 0)
    Case #PRODUCT_HOME_BASIC_E
      MessageRequester("", "Windows-Versionsbezeichnung: Home Basic - Not supported", 0)
    Case #PRODUCT_HOME_BASIC_N
      MessageRequester("", "Windows-Versionsbezeichnung: Home Basic N", 0)
    Case #PRODUCT_HOME_PREMIUM
      MessageRequester("", "Windows-Versionsbezeichnung: Home Premium", 0)
    Case #PRODUCT_HOME_PREMIUM_E
      MessageRequester("", "Windows-Versionsbezeichnung: Home Premium - Not supported", 0)
    Case #PRODUCT_HOME_PREMIUM_N
      MessageRequester("", "Windows-Versionsbezeichnung: Home Premium N", 0)
    Case #PRODUCT_HYPERV
      MessageRequester("", "Windows-Versionsbezeichnung: Microsoft Hyper-V Server", 0)
    Case #PRODUCT_MEDIUMBUSINESS_SERVER_MANAGEMENT
      MessageRequester("", "Windows-Versionsbezeichnung: Windows Essential Business Server Management Server", 0)
    Case #PRODUCT_MEDIUMBUSINESS_SERVER_MESSAGING
      MessageRequester("", "Windows-Versionsbezeichnung: Windows Essential Business Server Messaging Server", 0)
    Case #PRODUCT_MEDIUMBUSINESS_SERVER_SECURITY
      MessageRequester("", "Windows-Versionsbezeichnung: Windows Essential Business Server Security Server", 0)
    Case #PRODUCT_PROFESSIONAL
      MessageRequester("", "Windows-Versionsbezeichnung: Professional", 0)
    Case #PRODUCT_PROFESSIONAL_E
      MessageRequester("", "Windows-Versionsbezeichnung: Professional - Not supported", 0)
    Case #PRODUCT_PROFESSIONAL_N
      MessageRequester("", "Windows-Versionsbezeichnung: Professional N", 0)
    Case #PRODUCT_SERVER_FOR_SMALLBUSINESS
      MessageRequester("", "Windows-Versionsbezeichnung: Windows Server 2008 for Windows Essential Server Solutions", 0)
    Case #PRODUCT_SERVER_FOR_SMALLBUSINESS_V
      MessageRequester("", "Windows-Versionsbezeichnung: Windows Server 2008 without Hyper-V for Windows Essential Server Solutions", 0)
    Case #PRODUCT_SERVER_FOUNDATION
      MessageRequester("", "Windows-Versionsbezeichnung: Server Foundation", 0)
    Case #PRODUCT_HOME_PREMIUM_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Windows Home Server 2011", 0)
    Case #PRODUCT_SB_SOLUTION_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Windows Small Business Server 2011 Essentials", 0)
    Case #PRODUCT_HOME_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Windows Storage Server 2008 R2 Essentials", 0)
    Case #PRODUCT_SMALLBUSINESS_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Windows Small Business Server", 0)
    Case #PRODUCT_SOLUTION_EMBEDDEDSERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Windows MultiPoint Server", 0)
    Case #PRODUCT_STANDARD_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Server Standard (full installation)", 0)
    Case #PRODUCT_STANDARD_SERVER_CORE
      MessageRequester("", "Windows-Versionsbezeichnung: Server Standard (core installation)", 0)
    Case #PRODUCT_STANDARD_SERVER_CORE_V
      MessageRequester("", "Windows-Versionsbezeichnung: Server Standard without Hyper-V (core installation)", 0)
    Case #PRODUCT_STANDARD_SERVER_V
      MessageRequester("", "Windows-Versionsbezeichnung: Server Standard without Hyper-V (full installation)", 0)
    Case #PRODUCT_STARTER
      MessageRequester("", "Windows-Versionsbezeichnung: Starter", 0)
    Case #PRODUCT_STARTER_E
      MessageRequester("", "Windows-Versionsbezeichnung: Starter - Not supported", 0)
    Case #PRODUCT_STARTER_N
      MessageRequester("", "Windows-Versionsbezeichnung: Starter N", 0)
    Case #PRODUCT_STORAGE_ENTERPRISE_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Storage Server Enterprise", 0)
    Case #PRODUCT_STORAGE_EXPRESS_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Storage Server Express", 0)
    Case #PRODUCT_STORAGE_STANDARD_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Storage Server Standard", 0)
    Case #PRODUCT_STORAGE_WORKGROUP_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Storage Server Workgroup", 0)
    Case #PRODUCT_UNDEFINED
      MessageRequester("", "Windows-Versionsbezeichnung: Unbekanntes Produkt", 0)
    Case #PRODUCT_ULTIMATE
      MessageRequester("", "Windows-Versionsbezeichnung: Ultimate", 0)
    Case #PRODUCT_ULTIMATE_E
      MessageRequester("", "Windows-Versionsbezeichnung: Ultimate - Not supported", 0)
    Case #PRODUCT_ULTIMATE_N
      MessageRequester("", "Windows-Versionsbezeichnung: Ultimate N", 0)
    Case #PRODUCT_WEB_SERVER
      MessageRequester("", "Windows-Versionsbezeichnung: Web Server (full installation)", 0)
    Case #PRODUCT_WEB_SERVER_CORE
      MessageRequester("", "Windows-Versionsbezeichnung: Web Server (core installation)", 0)
  EndSelect
  
EndIf