EnableExplicit

Define EventID

Global NewList hIcons()

Procedure FreehIcons()
  ForEach hIcons()
    DestroyIcon_(hIcons())
  Next
  
EndProcedure

Procedure GetExtensionIcon(File$)
  Protected SHFILEINFO.SHFILEINFO
  Protected hIcon
  
  If SHGetFileInfo_(@File$, #FILE_ATTRIBUTE_NORMAL, @SHFILEINFO, SizeOf(SHFILEINFO), #SHGFI_SMALLICON | #SHGFI_ICON)
    hIcon = SHFILEINFO\hIcon
    
    AddElement(hIcons())
    hIcons() = hIcon
    
    ProcedureReturn hIcon
  EndIf
  
EndProcedure

If OpenWindow(0, 0, 0, 500, 400, "Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ImageGadget(1, 10, 10, 0, 0, GetExtensionIcon(GetEnvironmentVariable("windir") + "\explorer.exe"), 0)
  
  Repeat
    EventID = WaitWindowEvent()
    If EventID = #PB_Event_CloseWindow
      FreehIcons()
      End
    EndIf
  ForEver
EndIf