;Autor: edel
;http://www.purebasic.fr/german/viewtopic.php?p=323693#p323693

EnableExplicit

Import ""
  PB_Object_GetThreadMemory(obj)   
  PB_Gadget_Globals
EndImport

Structure PB_GadgetGlobals
  CurrentWindow.i
  FirstOptionGadget.i
  DefaultFont.i
  *PanelStack.integer
  PanelStackIndex.l
  PanelStackSize.l
  ToolTipWindow.i
EndStructure

Procedure GetToolTipHandle()
  Protected *winObj.PB_GadgetGlobals
  *winObj  = PB_Object_GetThreadMemory(PB_Gadget_Globals)
  ProcedureReturn *winObj\ToolTipWindow
EndProcedure

Procedure.l GadgetToolTipEx(Gadget, Text.s)
  Protected Info.TOOLINFO
  Protected hTip.i
  Protected hGadget
  
  hGadget = GadgetID(Gadget)
  
  If Not GetToolTipHandle()
    GadgetToolTip(Gadget, Text)
  EndIf
  
  hTip = GetToolTipHandle()
  
  Info\cbSize   = SizeOf(TOOLINFO)
  Info\uFlags   = #TTF_SUBCLASS|#TTF_IDISHWND
  Info\hWnd     = hGadget
  Info\uID      = hGadget
  Info\hInst    = GetModuleHandle_(0)
  Info\lpszText = @Text
  
  SendMessage_(hTip, #TTM_ADDTOOL, 0, @Info)
  SendMessage_(hTip, #TTM_SETMAXTIPWIDTH, 0, 1024)
  
  ProcedureReturn #True
EndProcedure

If OpenWindow(0, 0, 0, 500, 400, "Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ImageGadget(0, 20, 20, 150, 150, 0, #PB_Image_Border)
  GadgetToolTipEx(0, "Erste Zeile" + Chr(13) + "Zweite Zeile")
  
  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_CloseWindow
        End
    EndSelect
  ForEver
EndIf
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableXP
; EnableUser
; EnableCompileCount = 1
; EnableBuildCount = 0