EnableExplicit

Define lpdwFlags
Define lpszConnectionName$ = Space(255)

If InternetGetConnectedStateEx_(@lpdwFlags, @lpszConnectionName$, Len(lpszConnectionName$), #Null)
  Debug "Name der Verbindung: " + lpszConnectionName$
  If lpdwFlags & #INTERNET_CONNECTION_CONFIGURED
    Debug "Local system has a valid connection to the Internet, but it might or might not be currently connected."
  EndIf
  If lpdwFlags & #INTERNET_CONNECTION_OFFLINE
    Debug "Local system is in offline mode."
  EndIf
  If lpdwFlags & #INTERNET_RAS_INSTALLED
    Debug "Local system has RAS installed."
  EndIf
  If lpdwFlags & #INTERNET_CONNECTION_PROXY
    Debug "Local system uses a proxy server to connect to the Internet."
  EndIf
  If lpdwFlags & #INTERNET_CONNECTION_LAN
    Debug "Local system uses a local area network to connect to the Internet."
  EndIf
  If lpdwFlags & #INTERNET_CONNECTION_MODEM
    Debug "Local system uses a modem To connect To the Internet."
  EndIf
EndIf