;Autor: Rings
;http://www.purebasic.fr/english/viewtopic.php?p=184194#p184194

EnableExplicit

Structure STORAGE_PROPERTY_QUERY
  PropertyId.l
  QueryType.l
  AdditionalParameters.l
EndStructure

Structure STORAGE_DEVICE_DESCRIPTOR
  Version.l
  Size.l
  DeviceType.b
  DeviceTypeModifier.b
  RemovableMedia.b
  CommandQueueing.b
  VendorIdOffset.l
  ProductIdOffset.l
  ProductRevisionOffset.l
  SerialNumberOffset.l
  BusType.w
  RawPropertiesLength.l
  RawDeviceProperties.b
  Reserved.b[1024]
EndStructure

#BusTypeUnknown = 0
#BusTypeScsi = 1
#BusTypeAtapi = 2
#BusTypeAta = 3
#BusType1394 = 4
#BusTypeSsa = 5
#BusTypeFibre = 6
#BusTypeUsb = 7
#BusTypeRAID = 8
#BusTypeMaxReserved = $7F

#IOCTL_STORAGE_QUERY_PROPERTY = $2D1400

Define Drive$ = "\\.\G:";-Anpassen

Define hDrive
Define udtQuery.STORAGE_PROPERTY_QUERY
Define udtOut.STORAGE_DEVICE_DESCRIPTOR
Define p
Define lngResult
Define dwOutBytes

hDrive = CreateFile_(Drive$, 0, #FILE_SHARE_READ | #FILE_SHARE_WRITE, 0, #OPEN_EXISTING, 0, 0)
If hDrive <> -1
  For p=0 To 1023
    udtOut\Reserved[p]=0
  Next p
  
  lngResult = DeviceIoControl_(hDrive, #IOCTL_STORAGE_QUERY_PROPERTY, udtQuery, SizeOf(udtQuery), @udtOut, SizeOf(udtout), @dwOutBytes, 0)
  If lngResult
    If udtOut\Bustype = #BusTypeUsb
      Debug Drive$ + " ist eine USB-Festplatte"
    EndIf
  EndIf
EndIf

CloseHandle_(hDrive)
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP
; EnableUser
; EnableCompileCount = 0
; EnableBuildCount = 0