EnableExplicit

#EDD_GET_DEVICE_INTERFACE_NAME = $00000001

Define DISPLAY_DEVICE1.DISPLAY_DEVICE\cb = SizeOf(DISPLAY_DEVICE)
Define DISPLAY_DEVICE2.DISPLAY_DEVICE\cb = SizeOf(DISPLAY_DEVICE)
Define DeviceID$
Define hFile
Define pfOn

If OpenLibrary(0, "Kernel32.dll")
  Prototype GetDevicePowerState(hDevice, pfOn)
  Define GetDevicePowerState.GetDevicePowerState = GetFunction(0, "GetDevicePowerState")
  CloseLibrary(0)
EndIf

;Now standby display
SendMessage_(#HWND_BROADCAST,#WM_SYSCOMMAND,#SC_MONITORPOWER,2)
;Wait until the display is asleep
Delay(3000)
Beep_(1000, 100)

EnumDisplayDevices_(#Null, 0, @DISPLAY_DEVICE1, 0)
EnumDisplayDevices_(@DISPLAY_DEVICE1\DeviceName, #Null, @DISPLAY_DEVICE2, #EDD_GET_DEVICE_INTERFACE_NAME)
DeviceID$ = PeekS(@DISPLAY_DEVICE2\DeviceID[0])
If DeviceID$
  hFile = CreateFile_(DeviceID$, #GENERIC_READ, #FILE_SHARE_READ, 0, #OPEN_EXISTING, #FILE_ATTRIBUTE_READONLY, 0)
  If hFile
    If GetDevicePowerState(hFile, @pfOn)
      If pfOn = 1
        Debug "Display is ON"
      Else
        Debug "Display is OFF"
      EndIf
      
      Beep_(1000, 100)
    Else
      Debug "GetDevicePowerState failed"
    EndIf
    
    CloseHandle_(hFile)
  Else
    Debug "CreateFile failed"
  EndIf
Else
  Debug "EnumDisplayDevices failed"
EndIf
