EnableExplicit

Define EventID
Define GUITHREADINFO.GUITHREADINFO
Define rcCaret

#CURSOR_LTR = $f00c
#CURSOR_RTL = $f00d
#CURSOR_THAI = $f00e
#CURSOR_USA = $fff

If OpenWindow(0, 0, 0, 500, 400, "Window", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  GUITHREADINFO\cbSize = SizeOf(GUITHREADINFO)
  GetGUIThreadInfo_(GetCurrentThreadId_(), GUITHREADINFO)
  
  Debug "flags: " + GUITHREADINFO\flags
  Debug "hwndActive: " + GUITHREADINFO\hwndActive
  Debug "hwndCapture: " + GUITHREADINFO\hwndCapture
  Debug "hwndCaret: " + GUITHREADINFO\hwndCaret
  Debug "hwndFocus: " + GUITHREADINFO\hwndFocus
  Debug "hwndMenuOwner: " + GUITHREADINFO\hwndMenuOwner
  Debug "hwndMoveSize: " + GUITHREADINFO\hwndMoveSize
  rcCaret = GUITHREADINFO\rcCaret
  Select rcCaret
    Case #CURSOR_LTR
      Debug "Cursor: LTR"
    Case #CURSOR_RTL
      Debug "Cursor: RTL"
    Case #CURSOR_THAI
      Debug "Cursor: THAI"
    Case #CURSOR_USA
      Debug "Cursor: USA"
  EndSelect
  
  Repeat
    EventID = WaitWindowEvent()
    If EventID = #PB_Event_CloseWindow
      End
    EndIf
  ForEver
EndIf