;Autor: al90
;http://www.purebasic.fr/german/viewtopic.php?p=258440#p258440

EnableExplicit

Define file$

Procedure.i EnumWindowsCallBack(hwnd.i, Handle.i)
  Protected Title$ = Space(1024), ProcessID.i, st.i = #True

  GetWindowText_(hwnd, @Title$, Len(Title$))
  GetWindowThreadProcessId_(hwnd, @ProcessID)

  If Title$<>"" And IsWindowVisible_(hwnd)
    If ProcessID = PeekI(Handle)
      PokeI(Handle, hwnd)
      st = #False
    EndIf
  EndIf

  ProcedureReturn st
EndProcedure

Procedure.i Execute_WindowFile(Filename$, Parameter$, WorkDir$)
  Protected st.i, Handle.i, Check.i

  If FileSize(Filename$) > 0
    st = RunProgram(Filename$, Parameter$, WorkDir$, #PB_Program_Open)
  Else
    ProcedureReturn #Null
  EndIf

  Handle = ProgramID(st) : Check = Handle

  Repeat
    Delay(10)
    EnumWindows_(@EnumWindowsCallBack(), @Handle)
  Until Handle <> Check And IsWindow_(Handle) <> #Null

  CloseProgram(st)
  
  ProcedureReturn Handle
EndProcedure

file$ = GetEnvironmentVariable("SystemRoot") + "\System32\notepad.exe"
Debug "Handle-Nummer: " + Str(Execute_WindowFile(file$, "", ""))
; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 43
; Folding = -
; EnableXP
; EnableUser
; EnableCompileCount = 1
; EnableBuildCount = 0
; EnableUnicode