;Autor: pwd
;http://www.purebasic.fr/english/viewtopic.php?p=409426#p409426

EnableExplicit

Procedure BrowseCallbackProc(hwnd, msg, lParam, lData)
  Protected szDir$
  
  szDir$ = Space(#MAX_PATH)
  Select msg
    Case #BFFM_INITIALIZED
      SendMessage_(hwnd, #BFFM_SETSELECTION, #BFFM_INITIALIZED, lData)
      SendMessage_(hwnd, #BFFM_ENABLEOK, 0, 0)

    Case #BFFM_SELCHANGED
      If SHGetPathFromIDList_(lParam, @szDir$)
        SendMessage_(hwnd, #BFFM_SETSTATUSTEXT, 0, @szDir$)
        If szDir$ = "C:\"
          SendMessage_(hwnd, #BFFM_ENABLEOK, 0, 1)
        Else
          SendMessage_(hwnd, #BFFM_ENABLEOK, 0, 0)
        EndIf       
      EndIf
  EndSelect
EndProcedure

Procedure.s BrowseForFolder(Style, Titel.s, Path.s)
  Protected Folder.s
  Protected Dir.BROWSEINFO
  Protected result.l
  
  Folder.s = Space(#MAX_PATH)
  
  Dir\hwndOwner = GetActiveWindow_()
  Dir\pszDisplayName = @Folder
  Dir\lpszTitle = @Titel
  Dir\ulFlags = Style
  Dir\lpfn = @BrowseCallbackProc()
  Dir\lParam = @Path
  result.l = SHBrowseForFolder_(@Dir)
  SHGetPathFromIDList_(result, @Folder)
  If Folder <> ""
    If FileSize(Folder) = - 2
      If Right(Folder, 1) <> "\" : Folder + "\" : EndIf
    EndIf
  EndIf
  CoTaskMemFree_(result)
  ProcedureReturn Folder
EndProcedure

BrowseForFolder(#BIF_STATUSTEXT | #BIF_BROWSEINCLUDEFILES, "Whlen Sie ein Verzeichnis aus... (Nur C:\ kann ausgewhlt werden.)", "")
; IDE Options = PureBasic 5.31 (Windows - x64)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP
; EnableUser
; EnableCompileCount = 0
; EnableBuildCount = 0