EnableExplicit

Structure CPINFOEX
  MaxCharSize.l
  DefaultChar.b[#MAX_DEFAULTCHAR]
  LeadByte.b[#MAX_LEADBYTES]
  UnicodeDefaultChar.w
  CodePage.l
  CodePageName.b[#MAX_PATH]
EndStructure

Define CPINFOEX.CPINFOEX

If OpenLibrary(0, "Kernel32.dll")
  Prototype GetCPInfoEx(CodePage, dwFlags, lpCPInfoEx)
  Define GetCPInfoEx.GetCPInfoEx = GetFunction(0, "GetCPInfoExA")
  CloseLibrary(0)
EndIf

GetCPInfoEx(#CP_ACP, #Null, @CPINFOEX)

Debug "CodePage: " + CPINFOEX\CodePage
Debug "CodePage-Name: " + PeekS(@CPINFOEX\CodePageName)
Debug "Standard-Zeichen: " + PeekS(@CPINFOEX\DefaultChar)
Debug "Lnge des Standard-Zeichens: " + CPINFOEX\MaxCharSize
Debug "Standard-Unicode-Zeichen: " + PeekS(@CPINFOEX\UnicodeDefaultChar)