;Autor: RASHAD
;http://www.purebasic.fr/english/viewtopic.php?p=478545#p478545

EnableExplicit

#TVM_SETITEMHEIGHT  = $111B
#TVM_GETITEMHEIGHT  = $111C
#TVM_SETBKCOLOR     = $111D

Define Quit
Global hBrush
Global hBrush2
Global TVH

hBrush = CreateSolidBrush_($D7FEFE)
hBrush2 = CreateSolidBrush_(GetSysColor_(#COLOR_HIGHLIGHT))

Procedure WCallback(hWnd, uMsg, wParam, lParam)
  Protected result
  Protected *NMTVCUSTOMDRAW.NMTVCUSTOMDRAW
  Protected Item
  Protected RECT.RECT
  Protected TV_ITEM.TV_ITEM
  Protected tvi$
  
  result = #PB_ProcessPureBasicEvents
  
  Select uMsg
    Case  #WM_NOTIFY
      *NMTVCUSTOMDRAW.NMTVCUSTOMDRAW = lParam
      If *NMTVCUSTOMDRAW\nmcd\hdr\hwndFrom = GadgetID(0) And *NMTVCUSTOMDRAW\nmcd\hdr\code = #NM_CUSTOMDRAW   
        Select *NMTVCUSTOMDRAW\nmcd\dwDrawStage
          Case #CDDS_PREPAINT
            ProcedureReturn #CDRF_NOTIFYITEMDRAW
          Case #CDDS_ITEMPREPAINT
            ProcedureReturn #CDRF_NOTIFYPOSTPAINT
          Case #CDDS_ITEMPOSTPAINT
            Item = *NMTVCUSTOMDRAW\nmcd\dwItemSpec
            RECT.RECT\left = Item
            SendMessage_(GadgetID(0), #TVM_GETITEMRECT, #True, @RECT)           
            tvi$ = Space(#MAX_PATH)
            TV_ITEM\mask = #TVIF_HANDLE | #TVIF_PARAM | #TVIF_TEXT
            TV_ITEM\pszText = @tvi$
            TV_ITEM\cchTextMax = #MAX_PATH
            TV_ITEM\hItem = Item
            SendMessage_(GadgetID(0), #TVM_GETITEM, 0, TV_ITEM)
            SetBkMode_(*NMTVCUSTOMDRAW\nmcd\hdc, #TRANSPARENT)
            
            If *NMTVCUSTOMDRAW\nmcd\uItemState = #CDIS_FOCUS | #CDIS_SELECTED
              FillRect_(*NMTVCUSTOMDRAW\nmcd\hdc, RECT, hBrush2)
              SetTextColor_(*NMTVCUSTOMDRAW\nmcd\hdc, $FFFFFF)
            Else
              FillRect_(*NMTVCUSTOMDRAW\nmcd\hdc, RECT, hBrush)
              SetTextColor_(*NMTVCUSTOMDRAW\nmcd\hdc, 0)
            EndIf
            
            If FindString(tvi$, #CRLF$) > 0
              RECT\left + 2
              DrawText_(*NMTVCUSTOMDRAW\nmcd\hdc, tvi$, Len(tvi$), RECT, #DT_WORDBREAK)
            Else
              TextOut_(*NMTVCUSTOMDRAW\nmcd\hdc, RECT\left+2, RECT\top+14, tvi$, Len(tvi$))
            EndIf           
            
            ProcedureReturn #CDRF_NEWFONT           
        EndSelect
      EndIf
  EndSelect
  
  ProcedureReturn result
EndProcedure

LoadFont(0,"Tahoma",14)

If OpenWindow(0, 0, 0, 600, 400, "TreeGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  TreeGadget(0, 10, 10, 580, 380)
  SendMessage_(GadgetID(0), #TVM_SETBKCOLOR, 0, $D7FEFE)
  SetGadgetFont(0, FontID(0))
  TVH = SendMessage_(GadgetID(0), #TVM_GETITEMHEIGHT, 0, 0)
  SendMessage_(GadgetID(0), #TVM_SETITEMHEIGHT, TVH*2, 0)
  AddGadgetItem (0, -1, "First Main Node" + #CRLF$ + "Happ New Year", 0, 0)
  AddGadgetItem (0, -1, "Sub Item!" + #CRLF$ + "RASHAD", 0, 1)
  AddGadgetItem (0, -1, "Second Main Level Node" + #CRLF$ + "Happy New Year", 0, 0)
  AddGadgetItem(0, -1, "Sub text", 0, 1)
  AddGadgetItem(0, -1, "Third Node")
  
  SetWindowCallback(@WCallback())
  
  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_CloseWindow
        Quit = 1
    EndSelect
  Until Quit = 1
  DeleteObject_(hBrush)
  DeleteObject_(hBrush2)
EndIf